//Source for a igs_reg test program capable to change all igs vga registers
// in real time...
//Woody, April 1998

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/errno.h>
#include <fcntl.h>
#include "igsvga.h"
#include "top.h"
#include <termios.h>
#include <termcap.h>
/* RG - Stolen from top....
     * Set up the terminal attributes.
     */
void setup_terminal(void)
{
    char *termtype;
    struct termios newtty;

    termtype = getenv("TERM");
    if (!termtype) {
	/* In theory, $TERM should never not be set, but in practice,
	   some gettys don't.  Fortunately, vt100 is nearly always
	   correct (or pretty close). */
	termtype = "VT100";
	/* fprintf(stderr, PROGNAME ": $TERM not set\n"); */
	/* exit(1); */
    }

    /*
     * Get termcap entries and window size.
     */
    if(tgetent(NULL, termtype) != 1) {
       fprintf(stderr, PROGNAME ": Unknown terminal \"%s\" in $TERM\n",
               termtype);
       exit(1);
    }

    cm = tgetstr("cm", 0);
    top_clrtobot = tgetstr("cd", 0);
    cl = tgetstr("cl", 0);
    top_clrtoeol = tgetstr("ce", 0);
    ho = tgetstr("ho", 0);
    md = tgetstr("md", 0);
    mr = tgetstr("mr", 0);
    me = tgetstr("me", 0);

    newtty = Savetty;
    newtty.c_lflag &= ~ICANON;
    newtty.c_lflag &= ~ECHO;
    newtty.c_cc[VMIN] = 1;
    newtty.c_cc[VTIME] = 0;
    tcgetattr(0, &Rawtty);

}


main(int argc, char *argv[])
{
unsigned int regno, val, i;

int igsvga_fd=-1;
unsigned supported;
int source;

/*
struct
{
char	grf_reg[256];
char	atr_reg[20];
char	crt_reg[25];
char	seq_reg[5];
char	misc_reg;
}igs;
*/

IGSREGS	igs;

char szgrf[] = "Grf";
char szatr[] = "Atr";
char szcrt[] = "Crt";
char szseq[] = "Seq";
char szmisc[]= "Misc";
char szTV[]= "TV";
char szUnknown[] = "???";

char	c;
char*	szReg;

    igsvga_fd=open("/dev/igsvga",O_RDWR);
    if(igsvga_fd<0){
      perror("igs_reg: igsvga not found!");
      exit(-1);
    }

    source = (int)&igs;
    source = ioctl(igsvga_fd,IGSVGA_READ,&source);

    if (source < 0)
        printf("igsreg: IGS register dump returned error 0x%X!\n", source);   

    for(;;)
    {
	i=0;
	while(i<64)
	{
		printf("TV[%04X]%04X %04X %04X %04X.%04X %04X %04X %04X\n",
		0xE430+(i<<2),
		igs.tv_reg[i+0],
		igs.tv_reg[i+1],
		igs.tv_reg[i+2],
		igs.tv_reg[i+3],
		igs.tv_reg[i+4],
		igs.tv_reg[i+5],
		igs.tv_reg[i+6],
		igs.tv_reg[i+7]
		);
	i += 8;
	}
	sleep(1);
	tgoto("cm", 0, 0);
    }


	close(igsvga_fd);

}
